<?xml version="1.0" encoding="UTF-8"?>
<jube>
  <include-path>
  <path tag="galileo100">../../platform/galileo100</path>
  <path tag="marconi100">../../platform/marconi100</path>
  <path tag="marconi100">../../platform/leonardo</path>
  </include-path>

  <benchmark name="qe-ausurf" outpath="bench_run">
    <comment>Quantum Espresso PWSCF benchmark</comment>
    
    
<!-- Job configuration -->

    <!-- no. of nodes, tasks, etc -->
    <parameterset name="systemParameter" init_with="platform.xml">
    <parameter name="nodes" type="int" default="1">1,2,4</parameter>
    <parameter name="taskspernode" type="int" default="4">12</parameter>
    <parameter name="threadspertask">4</parameter>
    <parameter name="taskspersocket">6</parameter>
    <parameter name="ncores" type="int">48</parameter>
    <parameter name="accountno" >cin_staff</parameter>
    <parameter name="executable">cp.x</parameter> 
    <parameter name="args_executable">-nk $nodes -input $fin > $fout </parameter> 
    <parameter name="timelimit">01:00:00</parameter>
    <!--parameter name="gres" separator=";">gpu:4</parameter-->
    <parameter name="modules">module load autoload profile/chem-phys qe/7.1</parameter>
    <parameter name="args_exec"></parameter>
    <parameter name="ready_file">ready</parameter>
    </parameterset>

   <!-- running the job, llsubmit, runjob , etc -->
    <parameterset name="executeset" init_with="platform.xml">
    </parameterset>

    <!-- testcase parameters -->
    <parameterset name="testcaseset" init_with="workload.xml">
    </parameterset>

    <!-- files needed incl job file and input files -->
    <fileset name="jobfiles" init_with="platform.xml">
	    <copy>$jube_benchmark_home/../../workloads/qe/cp/$dirin/*</copy>
    </fileset>

    <!-- Substitute jobfile -->
    <substituteset name="executesub" init_with="platform.xml">
    <sub source="#ACCOUNT_NO#" dest="$accountno" />
    <sub source="#PREPROCESS#" dest="$modules" />
    <sub source="#MINMEM#" dest="$minmem" />
    <sub source="#READY#" dest="$ready_file" />
    </substituteset>

    <!-- Operation -->
    <step name="submit"  >
      <use>testcaseset</use>
      <use>systemParameter</use>
      <use>executeset</use>
      <use>jobfiles</use>
      <use>executesub</use>
      <do done_file="$ready_file" tag="!test">$submit $submit_script</do>--> <!-- actual submission directive -->
      <do>tail $fout | awk '/CPV/ {print $0}</do> <!--parse output with awk for total time-->
    </step>    
    <patternset name="pattern">
       <pattern name="electrons" type="float">electrons\s+:\s+${jube_pat_nfp}s CPU\s+${jube_pat_fp}s</pattern>
       <pattern name="cbands" type="float">c_bands\s+:\s+${jube_pat_nfp}s CPU\s+${jube_pat_fp}s</pattern>
       <pattern name="cdiaghg" type="float">cdiaghg\s+:\s+${jube_pat_nfp}s CPU\s+${jube_pat_fp}s</pattern>
       <pattern name="h_psi" type="float">h_psi\s+:\s+${jube_pat_nfp}s CPU\s+${jube_pat_fp}s</pattern>
       <pattern name="walltime" type="float">CPV\s+:\s+${jube_pat_nfp}s CPU\s+${jube_pat_fp}s</pattern>
    </patternset>

    <analyser name="analyse">
      <use>pattern</use>
      <analyse step="submit">
        <file>$fout</file>
      </analyse>
    </analyser>

    <result>
      <use>analyse</use>
      <table name="result" style="pretty" sort="nodes" tag="!csv">
        <column title="Nodes">nodes</column>
        <column title="Tasks/Node">taskspernode</column>
        <column title="Threads/Task">threadspertask</column>
        <column format=".2f" title="electrons">electrons</column>
        <column format=".2f" title="cbands">cbands</column>
        <column format=".2f" title="cdiaghg">cdiaghg</column>
        <column format=".2f" title="h_psi">h_psi</column>
        <column format=".2f" title="walltime">walltime</column>
      </table>
   </result>
  </benchmark>
</jube>
